function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 离线推送
 * @module OfflinePushManager(高级消息收发接口)
 */
export class V2TIMOfflinePushManager {
  /** @hidden */
  constructor(module) {
    _defineProperty(this, "nativeModule", void 0);

    _defineProperty(this, "manager", 'offlinePushManager');

    this.nativeModule = module;
  }
  /**
   * ### 设置离线推送配置信息
   */


  setOfflinePushConfig(businessID, token) {
    let isTPNSToken = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    return this.nativeModule.call(this.manager, 'setOfflinePushConfig', {
      businessID,
      token,
      isTPNSToken
    });
  }
  /**
   * APP 检测到应用退后台时可以调用此接口，可以用作桌面应用角标的初始化未读数量。
   * @param unreadCount 未读数量
   * @note
   * APP 检测到应用退后台时可以调用此接口，可以用作桌面应用角标的初始化未读数量。
   */


  doBackground(unreadCount) {
    return this.nativeModule.call(this.manager, 'doBackground', {
      unreadCount
    });
  }
  /**
   * APP 检测到应用进前台时可以调用此接口
   */


  doForeground() {
    return this.nativeModule.call(this.manager, 'doForeground', {});
  }

}
//# sourceMappingURL=v2_tim_offline_push_manager.js.map