/**
 * 离线推送
 * @module OfflinePushManager(高级消息收发接口)
 */
import type { V2TimCallback } from '../interface/v2TimCallback';
export declare class V2TIMOfflinePushManager {
    private nativeModule;
    private manager;
    /** @hidden */
    constructor(module: any);
    /**
     * ### 设置离线推送配置信息
     */
    setOfflinePushConfig(businessID: number, token: string, isTPNSToken?: boolean): Promise<V2TimCallback>;
    /**
     * APP 检测到应用退后台时可以调用此接口，可以用作桌面应用角标的初始化未读数量。
     * @param unreadCount 未读数量
     * @note
     * APP 检测到应用退后台时可以调用此接口，可以用作桌面应用角标的初始化未读数量。
     */
    doBackground(unreadCount: number): Promise<V2TimCallback>;
    /**
     * APP 检测到应用进前台时可以调用此接口
     */
    doForeground(): Promise<V2TimCallback>;
}
